<?php

if (!defined('ABSPATH')) {
	exit;
}

if (!class_exists('WP_List_Table')) {
	require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}

class WC_HC_Categories_Table extends WP_List_Table {
	function __construct() {
		parent::__construct(['plural' => 'e5_hc_categories']);

		// Define columns for this table
		$columns = $this->get_columns();
		$hidden = [];
		$sortable = $this->get_sortable_columns();
		$primary_column = 'name';

		$this->_column_headers = [$columns, $hidden, $sortable, $primary_column];
	}

	function get_columns() {
		return [
			'name'			=> __('Name', 'wc-hellocash'),
			'hc_category'	=> __('helloCash Category', 'wc-hellocash'),
		];
	}

	function get_sortable_columns() {
		return [
			// 'name' =>			['name', false],
			// 'hc_category' =>	['hc_category', false],
		];
	}

	function prepare_items() {
		// Configuration
		$per_page = -1;
		$pagenum = 0;

		$product_categories = get_terms('product_cat', [
			'number' => 0,
			'hide_empty' => false,
		]);

		$this->items = $product_categories;
	}

	// Render functions for columns
	function column_name($item) {
		return $item->name;
	}

	function column_hc_category($item) {
		$hc_category_id = get_option('e5_hc_category_map_'.$item->term_id);
		ob_start();
?>
			<input type="text" name="_e5_hc_category_<?php echo $item->term_id; ?>" value="<?php echo $hc_category_id; ?>" />
<?php
		$html = ob_get_contents();
		ob_end_clean();
		return $html;
	}

	function column_default($item, $column_name) {
		return '';
	}
}
