<?php

if (!defined('ABSPATH')) {
	exit;
}

class WC_HC_Logger {
	function __construct($order_id) {
		$this->order_id = $order_id;
		$this->_error_log = '';
	}

	public function log($message) {
		$this->_error_log .= gmdate('c') . ': '. $message . "\n";
	}

	public function save() {
		if (is_string($this->order_id) && substr($this->order_id, 0, 6) === "_e5_hc") {
			$old_log = get_option($this->order_id, '');
			$lines = preg_split("/\r\n|\n|\r/", $old_log . $this->_error_log);
			$lines = array_slice($lines, -10000);

			update_option(
				$this->order_id,
				implode(PHP_EOL, $lines)
			);
		} else {
			$old_log = get_post_meta($this->order_id, '_e5_hc_log', true);

			update_post_meta(
				$this->order_id,
				'_e5_hc_log',
				$old_log . $this->_error_log
			);
		}
	}
}
