<?php

if (!defined('ABSPATH')) {
	exit;
}


function e5_hc_add_order_meta_boxes() {
	global $post;

	if ($post->post_type != 'shop_order') {
		return;
	}

	$order = wc_get_order($post->ID);
	$order_invoice_id = get_post_meta($post->ID, '_e5_hc_invoice_id', true);
	$is_cancelled = get_post_meta($post->ID, '_e5_hc_invoice_cancelled', true);

	if ( ($order->get_status() == 'refunded' && $is_cancelled) ||
		 ($order->get_status() != 'refunded' && $order_invoice_id && !empty($order_invoice_id) && $order_invoice_id != -1)
		) {
		return;
	}

	add_meta_box(
		'e5_hc_status_box',
		'helloCash',
		'e5_hc_order_custom_admin_fields',
		'shop_order',
		'normal',
		'default'
	);
}
add_action('add_meta_boxes', 'e5_hc_add_order_meta_boxes');


function e5_hc_order_custom_admin_fields() {
	global $post;

	if ($post->post_type != 'shop_order') {
		return;
	}

	$order = wc_get_order($post->ID);
	$order_invoice_id = get_post_meta($post->ID, '_e5_hc_invoice_id', true);
	$order_debug = get_post_meta($post->ID, '_e5_hc_log', true);
	$is_cancelled = get_post_meta($post->ID, '_e5_hc_invoice_cancelled', true);

	if (
		(!$order_invoice_id || empty($order_invoice_id) || $order_invoice_id == -1) ||
		($order->get_status() == 'refunded' && !$is_cancelled)
	) {
		echo '<p><strong>';
		echo __('helloCash State', 'wc-hellocash');
		echo '</strong> ';

		$action = 'e5_hc_retry';
		if ($order->get_status() == 'refunded' && !$is_cancelled) {
			echo __('Failed to create helloCash refund', 'wc-hellocash');
			$action = 'e5_hc_retry_refund';
		} else {
			echo __('Failed to create helloCash invoice', 'wc-hellocash');
		}

		echo '</p>';
		echo '<a class="button" href="'.admin_url('admin-post.php').'?action='.$action.'&data='.$post->ID.'">';
		echo __('Retry', 'wc-hellocash');
		echo '</a>';

		if ($order_debug && !empty($order_debug)) {
			echo '<p><textarea rows="3" style="width: 100%">'.$order_debug.'</textarea></p>';
		}
	}
}


function e5_hc_retry() {
	$order_id = $_GET['data'];
	$order_invoice_id = get_post_meta($order_id, '_e5_hc_invoice_id', true);

	if (!$order_invoice_id || empty($order_invoice_id) || $order_invoice_id == -1) {
		delete_post_meta($order_id, '_e5_hc_invoice_id');
		$invoice = new WC_HC_Invoice($order_id);
		$invoice->create();
	}

	header('Location: /wp-admin/post.php?action=edit&post='.$order_id);
	exit();
}

add_action('admin_post_e5_hc_retry', 'e5_hc_retry');


function e5_hc_retry_refund() {
	$order_id = $_GET['data'];

	$order_invoice_id = get_post_meta($order_id, '_e5_hc_invoice_id', true);

	if ($order_invoice_id && !empty($order_invoice_id) && $order_invoice_id != -1) {
		// we have created an invoice so we also must create the reverse charge
		$refund = new WC_HC_Refund($order_id, $order_invoice_id);
		$refund->create();
	}

	header('Location: /wp-admin/post.php?action=edit&post='.$order_id);
	exit();
}

add_action('admin_post_e5_hc_retry_refund', 'e5_hc_retry_refund');
