<?php

if (!defined('ABSPATH')) {
	exit;
}


function e5_hc_order_status_changed($order_id, $status_from, $status_to) {
	$create_on_completed = false;
	$enabledOption = get_option('e5_hc_invoice_creation_completed');
	if (isset($enabledOption) && $enabledOption == true && $enabledOption != 'no') {
		$create_on_completed = true;
	}

	if (
		($status_to === 'processing' && $create_on_completed === false) ||
		($status_to === 'completed' && $create_on_completed === true)
	) {
		// This hook is used to create a new invoice in helloCash
		$invoice = new WC_HC_Invoice($order_id);
		$invoice->create();
		return;
	}

	if ($status_to === 'refunded') {
		// This hook is used to create a refund in helloCash
		$order_invoice_id = get_post_meta($order_id, '_e5_hc_invoice_id', true);

		if ($order_invoice_id && !empty($order_invoice_id)) {
			// we have created an invoice so we also must create the reverse charge
			$refund = new WC_HC_Refund($order_id, $order_invoice_id);
			$refund->create();
		}
		return;
	}
}

add_action('woocommerce_order_status_changed', 'e5_hc_order_status_changed', 11, 3);
